<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateScheduledAppointmentOutput StructType
 * @subpackage Structs
 */
class CreateScheduledAppointmentOutput extends AbstractStructBase
{
    /**
     * The ScheduledServiceDateId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ScheduledServiceDateId;
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * Constructor method for CreateScheduledAppointmentOutput
     * @uses CreateScheduledAppointmentOutput::setScheduledServiceDateId()
     * @uses CreateScheduledAppointmentOutput::setSuccess()
     * @uses CreateScheduledAppointmentOutput::setErrorMessage()
     * @param int $scheduledServiceDateId
     * @param bool $success
     * @param string $errorMessage
     */
    public function __construct($scheduledServiceDateId = null, $success = null, $errorMessage = null)
    {
        $this
            ->setScheduledServiceDateId($scheduledServiceDateId)
            ->setSuccess($success)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get ScheduledServiceDateId value
     * @return int
     */
    public function getScheduledServiceDateId()
    {
        return $this->ScheduledServiceDateId;
    }
    /**
     * Set ScheduledServiceDateId value
     * @param int $scheduledServiceDateId
     * @return \CustomerManagement\StructType\CreateScheduledAppointmentOutput
     */
    public function setScheduledServiceDateId($scheduledServiceDateId = null)
    {
        // validation for constraint: int
        if (!is_null($scheduledServiceDateId) && !(is_int($scheduledServiceDateId) || ctype_digit($scheduledServiceDateId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($scheduledServiceDateId, true), gettype($scheduledServiceDateId)), __LINE__);
        }
        $this->ScheduledServiceDateId = $scheduledServiceDateId;
        return $this;
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \CustomerManagement\StructType\CreateScheduledAppointmentOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \CustomerManagement\StructType\CreateScheduledAppointmentOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
}
